import weboob.browser.browsers as OLD

# can't import *, __all__ is incomplete...
for attr in dir(OLD):
    globals()[attr] = getattr(OLD, attr)

try:
    __all__ = OLD.__all__
except AttributeError:
    pass


# backport of GET/POST guessing 04681719ca54a061d2b4b35feabf484c80543cf1
def build_request(self, url, referrer=None, data_encoding=None, **kwargs):
    """
    Does the same job as open(), but returns a Request without
    submitting it.
    This allows further customization to the Request.
    """
    if isinstance(url, requests.Request):
        req = url
        url = req.url
    else:
        req = requests.Request(url=url, **kwargs)

    # guess method
    if req.method is None:
        # 'data' and 'json' (even if empty) are (always?) passed to build_request
        # and None is their default. For a Request object, the defaults are different.
        # Request.json is None and Request.data == [] by default.
        # Could they break unexpectedly?
        if (
            req.data or kwargs.get('data') is not None
            or req.json or kwargs.get('json') is not None
        ):
            req.method = 'POST'
        else:
            req.method = 'GET'

    # convert unicode strings to proper encoding
    if isinstance(req.data, unicode) and data_encoding:
        req.data = req.data.encode(data_encoding)
    if isinstance(req.data, dict) and data_encoding:
        req.data = OrderedDict([(k, v.encode(data_encoding) if isinstance(v, unicode) else v)
                                for k, v in req.data.items()])

    if referrer is None:
        referrer = self.get_referrer(self.url, url)
    if referrer:
        # Yes, it is a misspelling.
        req.headers.setdefault('Referer', referrer)

    return req


OLD.Browser.build_request = build_request


del OLD
